<?php

declare(strict_types=1);

namespace FiloBlu\Checkproducts\Cron;

use FiloBlu\Checkproducts\Helper\Email;
use FiloBlu\Checkproducts\Model\CollectorInterfaceFactory;
use FiloBlu\Checkproducts\Model\ProductCheckerInterfaceFactory;

/**
 *
 */
class Check
{
    /**
     * @var \FiloBlu\Checkproducts\Model\ProductCheckerInterfaceFactory
     */
    private $productCheckerFactory;
    /**
     * @var \FiloBlu\Checkproducts\Model\CollectorInterfaceFactory
     */
    private $collectorFactory;
    /**
     * @var \FiloBlu\Checkproducts\Helper\Email
     */
    private $emailHelper;

    /**
     * @param \FiloBlu\Checkproducts\Model\ProductCheckerInterfaceFactory $productCheckerFactory
     * @param \FiloBlu\Checkproducts\Model\CollectorInterfaceFactory $collectorFactory
     * @param \FiloBlu\Checkproducts\Helper\Email $emailHelper
     */
    public function __construct(
        ProductCheckerInterfaceFactory $productCheckerFactory,
        CollectorInterfaceFactory $collectorFactory,
        Email $emailHelper
    ) {
        $this->productCheckerFactory = $productCheckerFactory;
        $this->collectorFactory = $collectorFactory;
        $this->emailHelper = $emailHelper;
    }

    /**
     * @throws \Magento\Framework\Exception\MailException
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function execute()
    {
        $collector = $this->collectorFactory->create();
        $this->productCheckerFactory->create()->check($collector);
        $this->emailHelper->sendReport($collector);
    }
}